mod program_test;
use {
    mpl_token_metadata::accounts::{MasterEdition, Metadata},
    program_test::StablebondProgramTest,
    solana_program::{instruction::Instruction, system_instruction},
    solana_program_test::{tokio, ProgramTestContext},
    solana_sdk::{
        program_pack::Pack,
        pubkey::Pubkey,
        signature::{Keypair, Signer},
        transaction::Transaction,
    },
    spl_associated_token_account::{
        get_associated_token_address, get_associated_token_address_with_program_id,
    },
    spl_token_2022::{
        extension::StateWithExtensionsOwned,
        instruction as token_instruction,
        state::{Mint, Multisig},
    },
    stablebond_sdk::{
        accounts::{BondMultisigMeta, Issuance},
        find_bond_multisig_meta_pda, find_bond_pda, find_config_pda, find_delegate_pda,
        find_issuance_pda, find_kyc_pda, find_payment_feed_pda, find_payment_pda, find_payout_pda,
        instructions::{
            AddKycUser, InitializeBond, InitializeBondInstructionArgs, InitializeConfig,
            InitializeConfigInstructionArgs, InitializeDelegate, InitializeIssuance,
            InitializeIssuanceInstructionArgs, InitializePaymentFeed,
            InitializePaymentFeedInstructionArgs, MigrateMintAuthorityToMultisig, PurchaseBondV2,
            PurchaseBondV2InstructionArgs, StartIssuance,
        },
        types::{OracleSetup, PaymentFeedType},
    },
};

struct ExecuteTestContext {
    context: ProgramTestContext,
    user: Keypair,
    bond_mint: Keypair,
    usdc_mint: Pubkey,
    payment_base_price_feed_account: Pubkey,
    payment_quote_price_feed_account: Option<Pubkey>,
    delegate_wallet: Keypair,
}

async fn setup() -> ExecuteTestContext {
    let pt = StablebondProgramTest::start_new().await;
    let usdc_mint = pt.mints[0].payment_mint;
    let bond_mint = pt.bond_mints[0].insecure_clone();
    let admin = pt.admin;
    let user = pt.users[0].insecure_clone();
    let payment_base_price_feed_account = pt.stub_payment_feed.base_price_feed;
    let payment_quote_price_feed_account = None;
    let nft_collection_mint = pt.nft_collection_mint;

    let initialize_config_ix_args = InitializeConfigInstructionArgs {
        oracle: OracleSetup::Stub,
        usdc_mxn_payment_feed: pt.usdc_mxn_payment_feed.clone(),
        usdc_usd_payment_feed: pt.usdc_usd_payment_feed,
    };

    let initialize_config_ix = InitializeConfig {
        admin_wallet: admin.pubkey(),
        config_account: find_config_pda().0,
        config_token_account: get_associated_token_address(
            &find_config_pda().0,
            &nft_collection_mint.pubkey(),
        ),
        mint_account: nft_collection_mint.pubkey(),
        payment_mint_account: pt.usdc_mxn_payment_feed.payment_mint,
        metadata_account: Metadata::find_pda(&nft_collection_mint.pubkey()).0,
        master_edition_account: MasterEdition::find_pda(&nft_collection_mint.pubkey()).0,
        usdc_mxn_feed_account: find_payment_feed_pda(PaymentFeedType::UsdcMxn).0,
        usdc_usd_feed_account: find_payment_feed_pda(PaymentFeedType::UsdcUsd).0,
        token_program: spl_token::id(),
        associated_token_program: spl_associated_token_account::id(),
        metadata_program: mpl_token_metadata::ID,
        system_program: solana_program::system_program::id(),
    }
    .instruction(initialize_config_ix_args);

    let initialize_delegate_ix = InitializeDelegate {
        config_account: find_config_pda().0,
        admin_wallet: admin.pubkey(),
        delegate_wallet: admin.pubkey(),
        delegate_account: find_delegate_pda(admin.pubkey()).0,
        system_program: solana_program::system_program::id(),
    }
    .instruction();

    let initialize_payment_feed_args = InitializePaymentFeedInstructionArgs {
        payment_feed_info: pt.stub_payment_feed,
    };

    let initialize_payment_feed_ix = InitializePaymentFeed {
        delegate_wallet: admin.pubkey(),
        delegate_account: find_delegate_pda(admin.pubkey()).0,
        payment_feed_account: find_payment_feed_pda(PaymentFeedType::Stub).0,
        payment_mint_account: usdc_mint,
        system_program: solana_program::system_program::id(),
    }
    .instruction(initialize_payment_feed_args);

    let initialize_bond_ix_args = InitializeBondInstructionArgs {
        name: "Test Mint".to_string(),
        symbol: "TM".to_string(),
        uri: "https://test.com".to_string(),
        payment_feed_type: PaymentFeedType::Stub,
        cutoff_in_seconds: 60 * 60 * 24,
    };

    let initialize_bond_ix = InitializeBond {
        delegate_account: find_delegate_pda(admin.pubkey()).0,
        delegate_wallet: admin.pubkey(),
        bond_account: find_bond_pda(bond_mint.pubkey()).0,
        mint_account: bond_mint.pubkey(),
        metadata_account: Metadata::find_pda(&bond_mint.pubkey()).0,
        token2022_program: spl_token_2022::id(),
        metadata_program: mpl_token_metadata::ID,
        sysvar_instructions: solana_program::sysvar::instructions::id(),
        system_program: solana_program::system_program::id(),
    }
    .instruction(initialize_bond_ix_args);

    let current_time = StablebondProgramTest::get_current_time();
    let one_minute_ago: i64 = current_time - 60;
    let two_days_from_now: i64 = 60 * 60 * 24 * 2;

    let initialize_issuance_ix_args = InitializeIssuanceInstructionArgs {
        liquidity: 100_000_000,
        interest_rate_bps: 11_00,
        estimated_start_datetime: one_minute_ago,
        length_in_seconds: two_days_from_now,
    };

    let issuance_number = 1;
    let bond_pda = find_bond_pda(bond_mint.pubkey()).0;
    let issuance_pda = find_issuance_pda(bond_pda, issuance_number).0;
    let payment_pda = find_payment_pda(issuance_pda).0;
    let payout_pda = find_payout_pda(issuance_pda).0;
    let initialize_issuance_ix = InitializeIssuance {
        delegate_wallet: admin.pubkey(),
        delegate_account: find_delegate_pda(admin.pubkey()).0,
        bond_account: find_bond_pda(bond_mint.pubkey()).0,
        upcoming_issuance_account: issuance_pda,
        payment_feed_account: find_payment_feed_pda(PaymentFeedType::Stub).0,
        payment_mint_account: usdc_mint,
        payment_account: payment_pda,
        payment_token_account: get_associated_token_address(&payment_pda, &usdc_mint),
        payout_account: payout_pda,
        payout_token_account: get_associated_token_address(&payout_pda, &usdc_mint),
        associated_token_program: spl_associated_token_account::id(),
        token_program: spl_token::id(),
        system_program: solana_program::system_program::id(),
        current_issuance_account: None,
    }
    .instruction(initialize_issuance_ix_args);

    let start_issuance_ix = StartIssuance {
        delegate_account: find_delegate_pda(admin.pubkey()).0,
        delegate_wallet: admin.pubkey(),
        bond_account: find_bond_pda(bond_mint.pubkey()).0,
        issuance_account: find_issuance_pda(find_bond_pda(bond_mint.pubkey()).0, 1).0,
        mint_account: bond_mint.pubkey(),
        token2022_program: spl_token_2022::id(),
        system_program: solana_program::system_program::id(),
    }
    .instruction();

    let add_kyc_user_ix = AddKycUser {
        delegate_wallet: admin.pubkey(),
        delegate_account: find_delegate_pda(admin.pubkey()).0,
        wallet_account: user.pubkey(),
        kyc_account: find_kyc_pda(user.pubkey()).0,
        system_program: solana_program::system_program::id(),
    }
    .instruction();

    let ixs = &[
        initialize_config_ix,
        initialize_delegate_ix,
        initialize_payment_feed_ix,
        initialize_bond_ix,
        initialize_issuance_ix,
        start_issuance_ix,
        add_kyc_user_ix,
    ];

    let mut context = pt.context;
    let transaction = Transaction::new_signed_with_payer(
        ixs,
        Some(&admin.pubkey()),
        &[&admin, &nft_collection_mint, &bond_mint],
        context.last_blockhash,
    );

    context
        .banks_client
        .process_transaction(transaction)
        .await
        .unwrap();

    ExecuteTestContext {
        context,
        user,
        bond_mint,
        usdc_mint,
        payment_base_price_feed_account,
        payment_quote_price_feed_account,
        delegate_wallet: admin,
    }
}

#[tokio::test]
async fn migrate_mint_authority_to_multisig() {
    let mut et = setup().await;

    mint_before_migration(&mut et).await;

    // get mint account data
    let mint_account_data = et
        .context
        .banks_client
        .get_account(et.bond_mint.pubkey())
        .await
        .unwrap()
        .unwrap();
    let mint_account = StateWithExtensionsOwned::<Mint>::unpack(mint_account_data.data).unwrap();

    let bond_pda = find_bond_pda(et.bond_mint.pubkey()).0;

    // assert mint authority is Bond Mint PDA
    assert_eq!(mint_account.base.mint_authority, Some(bond_pda).into());

    // Create a new keypair for the multisig account
    let multisig_account = Keypair::new();

    // Create multisig with Bond Mint PDA as member
    let create_multisig_ixs = create_multisig(
        &et.delegate_wallet.pubkey(),
        &multisig_account.pubkey(),
        vec![bond_pda, Keypair::new().pubkey()], // randomly generated second member simulating a multisig with two members
        1,
    );

    // Create the migrate mint authority to multisig instruction
    let migrate_mint_authority_to_multisig_ix = MigrateMintAuthorityToMultisig {
        delegate_wallet: et.delegate_wallet.pubkey(),
        delegate_account: find_delegate_pda(et.delegate_wallet.pubkey()).0,
        mint_account: et.bond_mint.pubkey(),
        bond_account: find_bond_pda(et.bond_mint.pubkey()).0,
        bond_multisig_meta_account: find_bond_multisig_meta_pda(et.bond_mint.pubkey()).0,
        system_program: solana_program::system_program::id(),
        multisig_account: multisig_account.pubkey(),
        token2022_program: spl_token_2022::id(),
    }
    .instruction();

    // Combine all instructions
    let mut instructions = create_multisig_ixs;
    instructions.push(migrate_mint_authority_to_multisig_ix);

    // Send the transaction
    let recent_blockhash = et.context.last_blockhash;
    let transaction = Transaction::new_signed_with_payer(
        &instructions,
        Some(&et.delegate_wallet.pubkey()),
        &[&et.delegate_wallet, &multisig_account],
        recent_blockhash,
    );

    // Process the transaction
    et.context
        .banks_client
        .process_transaction(transaction)
        .await
        .unwrap();

    // Verify the mint authority was changed to the multisig
    // get mint account data
    let mint_account_data_after_migration = et
        .context
        .banks_client
        .get_account(et.bond_mint.pubkey())
        .await
        .unwrap()
        .unwrap();
    let mint_account_after_migration =
        StateWithExtensionsOwned::<Mint>::unpack(mint_account_data_after_migration.data).unwrap();

    // Verify that the bond multisig meta account was created and the mint authority is the multisig account
    let bond_multisig_meta_account_data = et
        .context
        .banks_client
        .get_account(find_bond_multisig_meta_pda(et.bond_mint.pubkey()).0)
        .await
        .unwrap()
        .unwrap();

    // assert bond multisig meta account multisig is the multisig account
    let bond_multisig_meta_account =
        BondMultisigMeta::from_bytes(&bond_multisig_meta_account_data.data).unwrap();
    assert_eq!(
        bond_multisig_meta_account.mint_auth_multisig,
        multisig_account.pubkey()
    );

    // assert mint authority is now the multisig account
    assert_eq!(
        mint_account_after_migration.base.mint_authority,
        Some(multisig_account.pubkey()).into()
    );

    mint_after_migration(&mut et, &multisig_account.pubkey()).await;
}

pub fn create_multisig(
    payer: &Pubkey,
    multisig_account: &Pubkey,
    members: Vec<Pubkey>,
    threshold: u8,
) -> Vec<Instruction> {
    // Calculate the space needed for the multisig account
    let space = Multisig::get_packed_len();
    let rent = solana_sdk::rent::Rent::default();
    let lamports = rent.minimum_balance(space);

    // Create the account
    let create_account_ix = system_instruction::create_account(
        payer,
        multisig_account,
        lamports,
        space as u64,
        &spl_token_2022::id(),
    );

    // Convert members to the correct type
    let member_refs: Vec<&Pubkey> = members.iter().collect();

    // Initialize the multisig
    let init_multisig_ix = token_instruction::initialize_multisig(
        &spl_token_2022::id(),
        multisig_account,
        &member_refs,
        threshold,
    )
    .unwrap();

    // Return both instructions
    vec![create_account_ix, init_multisig_ix]
}

async fn mint_before_migration(et: &mut ExecuteTestContext) {
    let recent_blockhash = et.context.last_blockhash;

    let payment_amount = 1_000_000;
    let purchase_bond_ix_args = PurchaseBondV2InstructionArgs {
        amount: payment_amount,
    };
    let bond_account = find_bond_pda(et.bond_mint.pubkey()).0;
    let issuance_account = find_issuance_pda(bond_account, 1).0;
    let kyc_account = find_kyc_pda(et.user.pubkey()).0;
    let payment_account = find_payment_pda(issuance_account).0;
    let payment_token_account = get_associated_token_address(&payment_account, &et.usdc_mint);
    let user_token_account = get_associated_token_address_with_program_id(
        &et.user.pubkey(),
        &et.bond_mint.pubkey(),
        &spl_token_2022::id(),
    );
    let user_payment_token_account = get_associated_token_address(&et.user.pubkey(), &et.usdc_mint);

    let purchase_bond_ix = PurchaseBondV2 {
        user_wallet: et.user.pubkey(),
        user_token_account,
        user_payment_token_account,
        bond_account,
        issuance_account,
        payment_account,
        payment_token_account,
        kyc_account,
        mint_account: et.bond_mint.pubkey(),
        payment_mint_account: et.usdc_mint,
        payment_feed_account: find_payment_feed_pda(PaymentFeedType::Stub).0,
        payment_base_price_feed_account: et.payment_base_price_feed_account,
        payment_quote_price_feed_account: et.payment_quote_price_feed_account,
        associated_token_program: spl_associated_token_account::id(),
        token_program: spl_token::id(),
        token2022_program: spl_token_2022::id(),
        system_program: solana_program::system_program::id(),
        mint_auth_multisig_account: None,
    }
    .instruction(purchase_bond_ix_args);

    let account = et
        .context
        .banks_client
        .get_account(issuance_account)
        .await
        .unwrap()
        .unwrap();

    let issuance = Issuance::from_bytes(&account.data).unwrap();
    let initial_liquidity = issuance.liquidity;

    let transaction = Transaction::new_signed_with_payer(
        &[purchase_bond_ix],
        Some(&et.user.pubkey()),
        &[&et.user],
        recent_blockhash,
    );

    assert!(et
        .context
        .banks_client
        .process_transaction(transaction)
        .await
        .is_ok());

    let account = et
        .context
        .banks_client
        .get_account(issuance_account)
        .await
        .unwrap()
        .unwrap();

    let issuance_account = Issuance::from_bytes(&account.data).unwrap();

    assert_eq!(
        issuance_account.liquidity,
        initial_liquidity - payment_amount
    );
}

async fn mint_after_migration(et: &mut ExecuteTestContext, multisig_account: &Pubkey) {
    let recent_blockhash = et.context.last_blockhash;

    let payment_amount = 1_000_000;
    let purchase_bond_ix_args = PurchaseBondV2InstructionArgs {
        amount: payment_amount,
    };
    let bond_account = find_bond_pda(et.bond_mint.pubkey()).0;
    let issuance_account = find_issuance_pda(bond_account, 1).0;
    let kyc_account = find_kyc_pda(et.user.pubkey()).0;
    let payment_account = find_payment_pda(issuance_account).0;
    let payment_token_account = get_associated_token_address(&payment_account, &et.usdc_mint);
    let user_token_account = get_associated_token_address_with_program_id(
        &et.user.pubkey(),
        &et.bond_mint.pubkey(),
        &spl_token_2022::id(),
    );
    let user_payment_token_account = get_associated_token_address(&et.user.pubkey(), &et.usdc_mint);

    let purchase_bond_ix = PurchaseBondV2 {
        user_wallet: et.user.pubkey(),
        user_token_account,
        user_payment_token_account,
        bond_account,
        issuance_account,
        payment_account,
        payment_token_account,
        kyc_account,
        mint_account: et.bond_mint.pubkey(),
        payment_mint_account: et.usdc_mint,
        payment_feed_account: find_payment_feed_pda(PaymentFeedType::Stub).0,
        payment_base_price_feed_account: et.payment_base_price_feed_account,
        payment_quote_price_feed_account: et.payment_quote_price_feed_account,
        associated_token_program: spl_associated_token_account::id(),
        token_program: spl_token::id(),
        token2022_program: spl_token_2022::id(),
        system_program: solana_program::system_program::id(),
        mint_auth_multisig_account: Some(*multisig_account),
    }
    .instruction(purchase_bond_ix_args);

    let account = et
        .context
        .banks_client
        .get_account(issuance_account)
        .await
        .unwrap()
        .unwrap();

    let issuance = Issuance::from_bytes(&account.data).unwrap();
    let initial_liquidity = issuance.liquidity;

    let transaction = Transaction::new_signed_with_payer(
        &[purchase_bond_ix],
        Some(&et.user.pubkey()),
        &[&et.user],
        recent_blockhash,
    );

    assert!(et
        .context
        .banks_client
        .process_transaction(transaction)
        .await
        .is_ok());

    let account = et
        .context
        .banks_client
        .get_account(issuance_account)
        .await
        .unwrap()
        .unwrap();

    let issuance_account = Issuance::from_bytes(&account.data).unwrap();

    assert_eq!(
        issuance_account.liquidity,
        initial_liquidity - payment_amount
    );
}
